#if 0
convcbd.exe: convcbd.c; cl /Ox /G6fy convcbd.c /MD /link /opt:nowin98
!if 0
#endif

//On 12/23/2003, I decided to port this to VC to make GLOBE.ZIP download smaller.
//File wasn't touched between 08/12/1999 and 12/23/2003

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <dos.h>
#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>

#define PI 3.14159265358979323

#define MAXFILES 256
long numfiles;
char filespec[MAXFILES][260];
char tempbuf[8192];

	//Keep track of how points from different files need to be scaled (yuk!)
long filepointstart[MAXFILES], filepointcnt;
double filepointlonunits[MAXFILES];

double ilonunits, dscale;
long px[16384], py[16384], ind[16384], s0[16384], s1[16384];

	//Huffman loading variables:
#define LOGHUFQSIZ 11
long hmaxbit, hqstart, hfrqend[4];
short hufi[2048], hufq[1<<LOGHUFQSIZ];

long bitval, bitpos;
long hfrq[2048], hufs[2048], hufc[2048], hfrqend[4];
FILE *infil, *outfil;

#define MAXPOINTS 4194304
typedef struct { long lng, lat; } lltype;
lltype *ll;
char *polineto;

static long pow2long[32] =
{
	0x1,0x2,0x4,0x8,0x10,0x20,0x40,0x80,0x100,0x200,0x400,0x800,0x1000,0x2000,
	0x4000,0x8000,0x10000,0x20000,0x40000,0x80000,0x100000,0x200000,0x400000,
	0x800000,0x1000000,0x2000000,0x4000000,0x8000000,0x10000000,0x20000000,
	0x40000000,0x80000000
};

#ifdef __WATCOMC__

void dcossin(double, double *, double *);
#pragma aux dcossin =\
	"fsincos",\
	"fstp qword ptr [eax]",\
	"fstp qword ptr [ebx]",\
	parm [8087][eax][ebx]\

void dtol(double, long *);
#pragma aux dtol =\
	"fistp dword ptr [eax]",\
	parm [8087][eax]\

long bsr(long);
#pragma aux bsr=\
	"bsr ecx, eax"\
	parm [eax]\
	value [ecx]\
	modify nomemory exact [ecx]\

long bswap(long);
#pragma aux bswap=\
	"bswap eax"\
	parm [eax]\
	value [eax]\
	modify nomemory exact [eax]\

static long fpuasm;
#pragma aux fifsyncmul =\
	"fild dword ptr [eax]"\
	"fld qword ptr [ebx]"\
	"fmulp st(1), st"\
	"fistp dword ptr [ecx]"\
	parm [eax][ebx][ecx]\
	modify exact \
	value \

//Ŀ
// Rounding: D11-10:   Precision: D9-8:   
//Ĵ
// 00 = near/even (0)  00 = 24-bit    (0) 
// 01 = -inf      (4)  01 = reserved  (1) 
// 10 = +inf      (8)  10 = 53-bit    (2) 
// 11 = 0         (c)  11 = 64-bit    (3) 
//

long asm;
#pragma aux fpuinit =\
	"fninit",\
	"fstcw asm",\
	"mov ah, byte ptr asm[1]",\
	"and ah, 0f0h",\
	"or ah, al",\
	"mov byte ptr asm[1], ah",\
	"fldcw asm",\
	parm [eax]\

#endif
#ifdef _MSC_VER

static _inline void dcossin (double a, double *c, double *s)
{
	_asm
	{
		fld a
		fsincos
		mov eax, c
		fstp qword ptr [eax]
		mov eax, s
		fstp qword ptr [eax]
	}
}

static _inline void dtol (double d, long *a)
{
	_asm
	{
		mov eax, a
		fld qword ptr d
		fistp dword ptr [eax]
	}
}

static __forceinline long bsr (long a) { _asm bsr eax, a }

static _inline unsigned long bswap (unsigned long a)
{
	_asm
	{
		mov eax, a
		bswap eax
	}
}

static _inline void fifsyncmul (long *a, double *b, long *c)
{
	_asm
	{
		mov eax, a
		fild dword ptr [eax]
		mov eax, b
		fld qword ptr [eax]
		fmulp st(1), st
		mov eax, c
		fistp dword ptr [eax]
	}
}

static long fpuasm[2];
static _inline void fpuinit (long a)
{
	_asm
	{
		mov eax, a
		fninit
		fstcw fpuasm
		and byte ptr fpuasm[1], 0f0h
		or byte ptr fpuasm[1], al
		fldcw fpuasm
	}
}

#endif

genhuf (long *frq, long num, long *bsym, long *bcnt)
{
	static long hind[2048], cfrq[2048*2], par[2048*2];
	long k, z, zz, m0, m1, n, r, danum, nodecnt, maxbits;

	//----------------------------------------------------
	//Given: frq&(0 to num%), Calculate bcnt%(0 to num%-1)

		//Init destroyable index and frequency tables
	nodecnt = 0;
	for(z=0;z<num;z++)
		if (frq[z]) { cfrq[z] = frq[z]; hind[nodecnt++] = z; }

		//Generate huffman tree by saving parent links
	danum = num;
	for(;nodecnt>=2;nodecnt--)
	{
		if (cfrq[hind[1]] < cfrq[hind[0]]) { m0 = 1; m1 = 0; } else { m0 = 0; m1 = 1; }
		for(z=nodecnt-1;z>=2;z--)
			if (cfrq[hind[z]] < cfrq[hind[m1]])
			{
				if (cfrq[hind[z]] < cfrq[hind[m0]])
					{ m1 = m0; m0 = z; } else { m1 = z; }
			}

		par[hind[m0]] = danum;
		par[hind[m1]] = danum+16384;
		cfrq[danum] = cfrq[hind[m0]] + cfrq[hind[m1]];
		hind[m0] = danum;               //Replace m0%
		hind[m1] = hind[nodecnt-1];  //Delete m1%
		danum++;
	}

		//Count bits per symbol
	danum--;
	for(z=0;z<num;z++)
	{
		if (frq[z])
		{
			zz = z; bcnt[z] = 0;
			while (zz != danum)
			{
				bcnt[z]++;
				zz = (par[zz]&16383);
			}
		}
		else
			bcnt[z] = 0;
	}

	//----------------------------------------------------
	//Given: bcnt%(0 to num%), Calculate bsym&(0 to num%-1)

		//Init destroyable index table
	nodecnt = 0;
	for(z=0;z<num;z++)
		if (bcnt[z] > 0) hind[nodecnt++] = z;

		//Sort symbol bit sizes
	for(z=1;z<nodecnt;z++)
		for(zz=0;zz<z;zz++)
			if (bcnt[hind[z]] < bcnt[hind[zz]])
				{ k = hind[z]; hind[z] = hind[zz]; hind[zz] = k; }

		//Generate symbols
	n = 0; maxbits = bcnt[hind[nodecnt-1]];
	for(z=0;z<nodecnt;z++)
	{
		r = 0;
		for(zz=maxbits-1;zz>=0;zz--)
			if (n&(1<<zz)) r += (1<<(maxbits-1-zz));
		bsym[hind[z]] = r;
		n += (1<<(maxbits-bcnt[hind[z]]));
	}
}

#define putbits(daval, dabits) \
{ \
	bitval += (daval<<bitpos); bitpos += dabits; \
	while (bitpos >= 8) \
	{ \
		fputc(bitval,outfil); \
		bitval >>= 8; bitpos -= 8; \
	} \
} \


	//Huffman loading variables (CONVCBD can load Ken's GLOBE format files too!)
inithuffman(long *bcnt, long *bsym, long num, short *ind, long *damaxbits, short *dahufq, long *hufqstart)
{
	long i, j, k, n, r, z, zz, maxbits, nodecnt;

		//Init destroyable index table
	nodecnt = 0;
	for(z=0;z<num;z++)
		if (bcnt[z]) ind[nodecnt++] = z;

		//Sort symbol bit sizes
	for(z=1;z<nodecnt;z++)
		for(zz=0;zz<z;zz++)
			if (bcnt[ind[z]] < bcnt[ind[zz]])
				{ i = ind[z]; ind[z] = ind[zz]; ind[zz] = i; }

		//Generate symbols
	memset(dahufq,0xff,2<<LOGHUFQSIZ); i = j = 0;
	n = 0; *damaxbits = maxbits = bcnt[ind[nodecnt-1]];
	for(z=0;z<nodecnt;z++)
	{
		n += pow2long[maxbits-bcnt[ind[z]]];
		bsym[z] = n;
		if (LOGHUFQSIZ >= bcnt[ind[z]])
		{
			*hufqstart = z+1;
			i += pow2long[LOGHUFQSIZ-bcnt[ind[z]]];
			while (j < i)
			{
				k = j++;
				for(zz=((LOGHUFQSIZ-1)>>1);zz>=0;zz--)  //Bit reversal: yuck!
					if (((k>>zz)^(k>>(LOGHUFQSIZ-1-zz)))&1)
						k ^= pow2long[zz]^pow2long[LOGHUFQSIZ-1-zz];
				dahufq[k] = ind[z];
			}
		}
	}
}
#define BITBUFSIZ 16384
static char bitbuf[BITBUFSIZ+4];
static long gbitpos, globedatfil;
initgetbits() { gbitpos = ((BITBUFSIZ+4)<<3); }
	//Warning: 0 <= dabits <= 25
long getbits(long dabits)
{
	long obitpos;

	if (gbitpos >= (BITBUFSIZ<<3))
	{
		gbitpos -= (BITBUFSIZ<<3);
		*((long *)&bitbuf[0]) = *((long *)&bitbuf[BITBUFSIZ]);
		read(globedatfil,&bitbuf[4],BITBUFSIZ);
	}
	obitpos = gbitpos; gbitpos += dabits;
	return(((*(long *)&bitbuf[obitpos>>3]) >> (obitpos&7)) & (pow2long[dabits]-1));
}
long lookbits (long dabits)
{
	if (gbitpos >= (BITBUFSIZ<<3))
	{
		gbitpos -= (BITBUFSIZ<<3);
		*((long *)&bitbuf[0]) = *((long *)&bitbuf[BITBUFSIZ]);
		read(globedatfil,&bitbuf[4],BITBUFSIZ);
	}
	return(((*(long *)&bitbuf[gbitpos>>3]) >> (gbitpos&7)) & (pow2long[dabits]-1));
}
void flushbits (long dabits) { gbitpos += dabits; }

#ifndef _WIN32
findfiles(char *dafilespec)
{
	struct find_t fileinfo;
	long i, daspeclen;
	char daspec[260];

	strcpy(daspec,dafilespec);
	for(daspeclen=0;daspec[daspeclen]!=0;daspeclen++);
	while ((daspec[daspeclen] != '\\') && (daspeclen > 0)) daspeclen--;
	if (daspeclen > 0) daspec[daspeclen++] = '\\';

	if (_dos_findfirst(dafilespec,_A_NORMAL,&fileinfo) != 0) return;
	do
	{
		strcpy(filespec[numfiles],daspec);
		strcpy(&filespec[numfiles][daspeclen],fileinfo.name);

		numfiles++;
		if (numfiles > MAXFILES)
		{
			printf("FATAL ERROR: TOO MANY FILES SELECTED! (MAX is 4096)\n");
			exit(0);
		}
	} while (_dos_findnext(&fileinfo) == 0);
}
#else
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
void findfiles (char *dafilespec)
{
	long daspeclen;
	HANDLE hfind;
	WIN32_FIND_DATA findata;
	char daspec[260];

	strcpy(daspec,dafilespec);
	for(daspeclen=0;daspec[daspeclen]!=0;daspeclen++);
	while ((daspec[daspeclen] != '\\') && (daspeclen > 0)) daspeclen--;
	if (daspeclen > 0) daspec[daspeclen++] = '\\';

	hfind = FindFirstFile(dafilespec,&findata);
	if (hfind == INVALID_HANDLE_VALUE) return;
	do
	{
		if (findata.dwFileAttributes&FILE_ATTRIBUTE_HIDDEN) continue;
		if ((findata.cFileName[0] == '.') && (!findata.cFileName[1])) continue;

		strcpy(filespec[numfiles],daspec);
		if (daspeclen+strlen(findata.cFileName) >= 260) continue;
		strcpy(&filespec[numfiles][daspeclen],findata.cFileName);

		numfiles++;
		if (numfiles > MAXFILES)
		{
			printf("FATAL ERROR: TOO MANY FILES SELECTED! (MAX is 4096)\n");
			exit(0);
		}
	} while (FindNextFile(hfind,&findata));
	FindClose(hfind);
}

#endif

	//Returns data in ind[] and count in return value
long Ken_DPline(long *dpx, long *dpy, long inum, double tolerance)
{
	double x0, y0, z0, x1, y1, z1, x2, y2, z2, x3, y3, z3, dsqr, maxdsqr, f;
	double rdist, minarea;
	long i, i0, i1, nleft, onum, s;

	if (tolerance <= 0)
	{
		for(i=0;i<inum;i++) ind[i] = i;
		return(inum);
	}

	tolerance /= 6371.007181;  //Divide by radius of the Earth (units in km)
	tolerance *= tolerance;

	onum = 0;

	f = dscale;

		//init stack
	s0[0] = 0; s1[0] = inum-1; nleft = 1;

	//ind[onum++] = 0;  //Force first point on list
	do
	{
		nleft--; i0 = s0[nleft]; i1 = s1[nleft];
		if (i1-i0 > 1)
		{
			x0 = cos(dpy[i0]*f)*cos(dpx[i0]*f);
			y0 = cos(dpy[i0]*f)*sin(dpx[i0]*f);
			z0 = sin(dpy[i0]*f);

			x2 = cos(dpy[i1]*f)*cos(dpx[i1]*f);
			y2 = cos(dpy[i1]*f)*sin(dpx[i1]*f);
			z2 = sin(dpy[i1]*f);

			rdist = ((x2-x0)*(x2-x0) + (y2-y0)*(y2-y0) + (z2-z0)*(z2-z0));
			if (rdist != 0) rdist = 1.0 / rdist;

			maxdsqr = -1;
			for(i=i0+1;i<i1;i++)  //Find farthest point from line
			{
				x1 = cos(dpy[i]*f)*cos(dpx[i]*f);
				y1 = cos(dpy[i]*f)*sin(dpx[i]*f);
				z1 = sin(dpy[i]*f);

				if (rdist == 0)
					dsqr = (x1-x0)*(x1-x0) + (y1-y0)*(y1-y0) + (z1-z0)*(z1-z0);
				else
				{
						//dsqr = (3D distance between point 1 and line 0-2)
					if ((x1-x0)*(x2-x0) + (y1-y0)*(y2-y0) + (z1-z0)*(z2-z0) < 0)
						dsqr = (x1-x0)*(x1-x0) + (y1-y0)*(y1-y0) + (z1-z0)*(z1-z0);
					else if ((x1-x2)*(x0-x2) + (y1-y2)*(y0-y2) + (z1-z2)*(z0-z2) < 0)
						dsqr = (x1-x2)*(x1-x2) + (y1-y2)*(y1-y2) + (z1-z2)*(z1-z2);
					else
					{
						dsqr = ((x1-x0)*(x2-x0) + (y1-y0)*(y2-y0) + (z1-z0)*(z2-z0)) * rdist;
						x3 = x0 + (x2-x0)*dsqr;
						y3 = y0 + (y2-y0)*dsqr;
						z3 = z0 + (z2-z0)*dsqr;
						dsqr = (x3-x1)*(x3-x1) + (y3-y1)*(y3-y1) + (z3-z1)*(z3-z1);
					}
				}
				if (dsqr >= maxdsqr) { maxdsqr = dsqr; s = i; }
			}
			if (maxdsqr >= tolerance)
			{     //DO NOT REVERSE THESE!
				s0[nleft] = s; s1[nleft] = i1;
				s0[nleft+1] = i0; s1[nleft+1] = s;
				nleft += 2;
			}
			else ind[onum++] = i0;
		}
		else ind[onum++] = i0;
	} while (nleft > 0);
	ind[onum++] = inum-1;  //Force last point on list

	//if ((ind[0] == ind[1]) && (onum > 1)) //Oops! Don't include first point twice
	//{
	//   onum--;
	//   for(i=onum-1;i>0;i--) ind[i] = ind[i+1];
	//}

	return(onum);
}

main(int argc, char **argv)
{
	double maxdist, tolerance;
	double t, r2thresh, odx, ody, odz, ndx, ndy, ndz, dascale;
	double flat, flng, px0, py0, pz0, px1, py1, pz1, px2, py2, pz2;
	long fileid, dictaddr, segcount, segsize, segmax;
	long maxlat, minlat, maxlong, minlong, features, scale_shift;
	long lat_offset, lng_offset, dobswap, danumpoints, ix, iy, lonunits2;
	long segid, ymax, ymin, xmax, xmin, absaddr, newnumpoints, numpolbords;
	long i, j, k, l, n, p, x, y, z, dx, dy, fcnt, numpoints, numstrings;
	long lng, lat, id, suckit, splitit, nx, ny, ox, oy, lx, ly, templong;
	long olonunits, hlonunits, qlonunits, log2lonunits;
	short tempshort, nbytes, rank, nstrokes, dummy;
	char infilename[256], outfilename[256];

	if (argc != 6)
	{
		printf("ConvCBD converts/combines/compresses .CBD&GLOBE files      by Ken Silverman\n");
		printf("   .CBD files can be either version 0x20770002 (old) or 0x20770033 (new)\n");
		printf("   .CBD files must have .CBD extension, other files loaded as GLOBE files\n");
		printf("   -autodetects whether .CBD file is in Big or Little Endian format \n\n");
		printf("Command line: >convcbd [infile] [outfile] [tolerance] [maxdist] [# angles]\n");
		printf("   [infile]: Can be a single file such as BRD.CBD or BORDH.DAT, but to make\n");
		printf("      this program more useful, put a @ in front of the name, and ConvCBD\n");
		printf("      will combine all converted files listed in this file\n");
		printf("   [outfile]: Output filename (in Ken's super-compressed GLOBE .DAT format)\n");
		printf("   [tolerance]: Remove line info less significant than this length (in km)\n");
		printf("       (Uses a form of the Douglas-Peucker algorithm)\n");
		printf("   [maxdist]: Maximum line length (in km).  Lower this value to force long\n");
		printf("      straight lines to curve around the surface of the Earth better\n");
		printf("   [# angles]: Quantize angles to: 1: 360, 01': 21600, 00'1\": 1296000, etc.\n\n");
		printf("Example 1:  >convcbd @brds.txt bordl.dat 16 200 16384     <- lo-res borders\n");
		printf("Example 2:  >convcbd @brds.txt bordx.dat 5 100 65536      <- med-res borders\n");
		printf("Example 3:  >convcbd @brds.txt bordh.dat .2 10 524288     <- hi-res borders\n");
		printf("Example 4:  >convcbd @rivs.txt bordr.dat 2 100 131072     <- rivers\n");
		exit(0);
	}

	setbuf(stdout,0);
	fpuinit(0x03);  //64 bit, round to +near/even

	numfiles = 0;
	strcpy(infilename,argv[1]);
	if (infilename[0] == '@')
	{
		if ((infil = fopen(&infilename[1],"rb")) != NULL)
		{
			j = 0; l = fread(tempbuf,1,sizeof(tempbuf),infil);
			while ((j < l) && (tempbuf[j] <= 32)) j++;
			while (j < l)
			{
				k = j;
				while ((k < l) && (tempbuf[k] > 32)) k++;

				tempbuf[k] = 0;
				findfiles(&tempbuf[j]);
				j = k+1;

				while ((j < l) && (tempbuf[j] <= 32)) j++;
			}
			fclose(infil);
		}
	}
	else
		findfiles(infilename);

	strcpy(outfilename,argv[2]);
	tolerance = atof(argv[3]);
	maxdist = atof(argv[4]);
	olonunits = atol(argv[5]);

	if (olonunits > 33554432)
		{ printf("olonunits must be < 33554432 because huffman code only reads 25 bits\n"); exit(0); }

	maxdist /= 6371.007181;  //Divide by radius of the Earth (units in km)
	maxdist *= maxdist;

	numpoints = 0;

	if (!(ll = (lltype *)malloc(MAXPOINTS*sizeof(lltype))))
		{ printf("Not enough memory (ll)\n"); exit(0); }

	if (!(polineto = (char *)malloc(MAXPOINTS>>3)))
		{ printf("Not enough memory (polineto)\n"); exit(0); }
	memset(polineto,0,MAXPOINTS>>3);

	for(fcnt=0;fcnt<numfiles;fcnt++)
	{
		filepointstart[fcnt] = numpoints;

		i = strlen(filespec[fcnt]);
		if ((filespec[fcnt][i-4] == '.') &&
			((filespec[fcnt][i-3] == 'C') || (filespec[fcnt][i-3] == 'c')) &&
			((filespec[fcnt][i-2] == 'B') || (filespec[fcnt][i-2] == 'b')) &&
			((filespec[fcnt][i-1] == 'D') || (filespec[fcnt][i-1] == 'd')))
		{
			printf("Loading CBD file: %s\n",filespec[fcnt]);
			infil = fopen(filespec[fcnt],"rb");
			fread(&fileid,4,1,infil);   //0x20770002 (old), 0x20770033 (extended)
			fread(&dictaddr,4,1,infil); //Offset of segment dictionary in file  (offset loopnum)
			fread(&segcount,4,1,infil); //Number of segments in file   (numloops)
			fread(&segsize,4,1,infil);  //Size of segment dictionary   (segcount*28)
			fread(&segmax,4,1,infil);   //Size of largest segment's strokes, /2
			dobswap = -1;
			if ((fileid == 0x20770002) || (fileid == 0x20770033)) dobswap = 0;
			if ((fileid == 0x02007720) || (fileid == 0x33007720)) dobswap = 1;
			if (dobswap < 0)
			{
				printf("ERROR: %s has invalid header\n",infilename);
				continue;
			}
			if (dobswap)
			{
				fileid = bswap(fileid);
				dictaddr = bswap(dictaddr);
				segcount = bswap(segcount);
				segsize = bswap(segsize);
				segmax = bswap(segmax);
			}
			ilonunits = 1296000.0;
			if (fileid == 0x20770033)
			{
				fread(&maxlat,4,1,infil);
				fread(&minlat,4,1,infil);
				fread(&maxlong,4,1,infil);
				fread(&minlong,4,1,infil);     //Bounding box of map
				fread(&features,4,1,infil);    //bits indicate feature "ranks" present
				fread(&scale_shift,4,1,infil); //bits to shift coordinate data
				fread(&lat_offset,4,1,infil);  //lattitude offset
				fread(&lng_offset,4,1,infil);  //longitude offset
				if (dobswap)
				{
					maxlat = bswap(maxlat);
					minlat = bswap(minlat);
					maxlong = bswap(maxlong);
					minlong = bswap(minlong);
					features = bswap(features);
					scale_shift = bswap(scale_shift);
					lat_offset = bswap(lat_offset);
					lng_offset = bswap(lng_offset);
				}
				ilonunits *= pow(2.0,scale_shift);
			}
			else { scale_shift = lat_offset = lng_offset = 0; }
			dscale = (PI*2.0)/ilonunits;
			dtol(ilonunits,&lonunits2);
			printf("File has lonunits:%f\n",ilonunits);

			for(l=0;l<segcount;l++)
			{
				fseek(infil,dictaddr+l*28,SEEK_SET);
				fread(&segid,4,1,infil);
				fread(&ymax,4,1,infil);
				fread(&ymin,4,1,infil);
				fread(&xmax,4,1,infil);
				fread(&xmin,4,1,infil);
				fread(&absaddr,4,1,infil);
				fread(&nbytes,2,1,infil);
				fread(&rank,2,1,infil);
				if (dobswap)
				{
					segid = bswap(segid);
					ymax = bswap(ymax);
					ymin = bswap(ymin);
					xmax = bswap(xmax);
					xmin = bswap(xmin);
					absaddr = bswap(absaddr);
					nbytes = ((nbytes>>8)&0x00ff)+((nbytes<<8)&0xff00);
					rank = ((rank>>8)&0x00ff)+((rank<<8)&0xff00);
				}

				fseek(infil,absaddr,SEEK_SET);
				fread(&lng,4,1,infil);
				fread(&lat,4,1,infil);
				fread(&id,4,1,infil);
				fread(&nstrokes,2,1,infil);
				fread(&dummy,2,1,infil);
				if (dobswap)
				{
					lng = bswap(lng);
					lat = bswap(lat);
					id = bswap(id);
					nstrokes = ((nstrokes>>8)&0x00ff)+((nstrokes<<8)&0xff00);
					dummy = ((dummy>>8)&0x00ff)+((dummy<<8)&0xff00);
				}
				lng += lng_offset;
				lat += lat_offset;

				px[0] = lng; py[0] = lat; danumpoints = 1;

				for(p=0;p<nstrokes;p++)
				{
					fread(&tempshort,2,1,infil);
					if (dobswap) tempshort = ((tempshort>>8)&0x00ff)+((tempshort<<8)&0xff00);
					if (tempshort&16384)
					{
							//X1xxxxxxYyyyyyyy  X:-64 to 63, Y:-128 to 127
						templong = (long)tempshort;
						if (templong > 0) templong &= ~16384;
						dx = ((templong>>8)&255); if (dx&128) dx |= 0xffffff00;
						dy = (templong&255); if (dy&128) dy |= 0xffffff00;
					}
					else
					{
							//X0xxxxxx xxxxxxxx xxxxxxxx xxxxxxxx
							//Yyyyyyyy yyyyyyyy yyyyyyyy yyyyyyyy
						dx = (long)tempshort; if (tempshort < 0) dx |= 16384;
						fread(&tempshort,2,1,infil);
						if (dobswap) tempshort = ((tempshort>>8)&0x00ff)+((tempshort<<8)&0xff00);
						templong = tempshort; dx = (dx<<16) + (templong&65535);
						fread(&tempshort,2,1,infil);
						if (dobswap) tempshort = ((tempshort>>8)&0x00ff)+((tempshort<<8)&0xff00);
						dy = tempshort; if (dy < 0) dy |= 16384;
						fread(&tempshort,2,1,infil);
						if (dobswap) tempshort = ((tempshort>>8)&0x00ff)+((tempshort<<8)&0xff00);
						templong = tempshort; dy = (dy<<16) + (templong&65535);
					}

					lng += dx; px[danumpoints] = lng;
					lat += dy; py[danumpoints] = lat;
					danumpoints++;
				}

				danumpoints = Ken_DPline(px,py,danumpoints,tolerance);
				polineto[numpoints>>3] |= (1<<(numpoints&7));
				ll[numpoints].lng = px[ind[0]];
				ll[numpoints].lat = py[ind[0]];
				numpoints++;
				for(i=1;i<danumpoints;i++)
				{
					dcossin(((double)py[ind[i-1]])*dscale,&t,&py1);
					dcossin(((double)px[ind[i-1]])*dscale,&pz1,&px1);
					px1 *= t; py1 = -py1; pz1 *= -t;
					dcossin(((double)py[ind[i]])*dscale,&t,&py2);
					dcossin(((double)px[ind[i]])*dscale,&pz2,&px2);
					px2 *= t; py2 = -py2; pz2 *= -t;
					t = (px2-px1)*(px2-px1) + (py2-py1)*(py2-py1) + (pz2-pz1)*(pz2-pz1);
					if (t > maxdist)
					{
						dtol(sqrt(t/maxdist),&splitit);
						if (splitit > 1)
						{
							t = 1.0 / splitit;
							dx = px[ind[i]] - px[ind[i-1]];
							dy = py[ind[i]] - py[ind[i-1]];
							for(z=splitit-1;z>0;z--)
							{
								dtol((double)px[ind[i]] - (double)dx*t*z,&ll[numpoints].lng);
								dtol((double)py[ind[i]] - (double)dy*t*z,&ll[numpoints].lat);
								numpoints++;
							}
						}
					}

					ll[numpoints].lng = px[ind[i]];
					ll[numpoints].lat = py[ind[i]];
					numpoints++;
				}
			}
			fclose(infil);
		}
		else
		{
			printf("Loading GLOBE file: %s\n",filespec[fcnt]);

			if ((globedatfil = open(filespec[fcnt],O_BINARY|O_RDONLY)) == -1)
				{ printf("Can't load %s\n",filespec[fcnt]); exit(0); }

			read(globedatfil,&lonunits2,4);  //Total number of discrete units of longitude
			ilonunits = lonunits2;
			printf("File has lonunits:%f\n",ilonunits);

			dscale = (PI*2.0)/ilonunits;

			hlonunits = (lonunits2>>1);
			for(log2lonunits=0;pow2long[log2lonunits]<lonunits2;log2lonunits++);

			read(globedatfil,&numpolbords,4);

			initgetbits();

				//Load huffman tables for both X and Y coordinates
			for(z=0;z<4;z++) hfrqend[z] = getbits(5);
			memset(hufc,0,sizeof(hufc));
			for(j=0;j<hfrqend[1];j++)
				for(i=0;i<hfrqend[0];i++)
					hufc[(j<<5)+i] = getbits(5);
			for(j=0;j<hfrqend[3];j++)
				for(i=0;i<hfrqend[2];i++)
					hufc[(j<<5)+i+1024] = getbits(5);
			inithuffman(hufc,hufs,2048,hufi,&hmaxbit,hufq,&hqstart);

			danumpoints = 0;
			lng = lat = 0;
			for(i=0;i<numpolbords;i++)
			{
					//Huffman get lng & lat exponents
				ix = hufq[lookbits(LOGHUFQSIZ)];
				if (ix < 0)
				{
					k = lookbits(hmaxbit);
					for(z=((hmaxbit-1)>>1);z>=0;z--)  //Bit reversal: yuck!
						if (((k>>z)^(k>>(hmaxbit-1-z)))&1)
							k ^= pow2long[z]^pow2long[hmaxbit-1-z];
					for(z=hqstart;k>=hufs[z];z++);
					ix = hufi[z];
				}
				flushbits(hufc[ix]);

				if ((ix&1024) && (i))
				{
					danumpoints = Ken_DPline(px,py,danumpoints,tolerance);
					polineto[numpoints>>3] |= (1<<(numpoints&7));
					ll[numpoints].lng = px[ind[0]];
					ll[numpoints].lat = py[ind[0]];
					numpoints++;
					for(j=1;j<danumpoints;j++)
					{
						dcossin(((double)py[ind[j-1]])*dscale,&t,&py1);
						dcossin(((double)px[ind[j-1]])*dscale,&pz1,&px1);
						px1 *= t; py1 = -py1; pz1 *= -t;
						dcossin(((double)py[ind[j]])*dscale,&t,&py2);
						dcossin(((double)px[ind[j]])*dscale,&pz2,&px2);
						px2 *= t; py2 = -py2; pz2 *= -t;
						t = (px2-px1)*(px2-px1) + (py2-py1)*(py2-py1) + (pz2-pz1)*(pz2-pz1);
						if (t > maxdist)
						{
							dtol(sqrt(t/maxdist),&splitit);
							if (splitit > 1)
							{
								t = 1.0 / splitit;
								dx = px[ind[j]] - px[ind[j-1]];
								dy = py[ind[j]] - py[ind[j-1]];
								for(z=splitit-1;z>0;z--)
								{
									dtol((double)px[ind[j]] - (double)dx*t*z,&ll[numpoints].lng);
									dtol((double)py[ind[j]] - (double)dy*t*z,&ll[numpoints].lat);
									numpoints++;
								}
							}
						}
						ll[numpoints].lng = px[ind[j]];
						ll[numpoints].lat = py[ind[j]];
						numpoints++;
					}
					danumpoints = 0;
				}

				iy = (ix>>5)&31; ix &= 31;

				if (ix > 0)
				{
					if (ix > 1) ix = getbits(ix-1)+pow2long[ix-1];
					if (getbits(1)) ix = -ix;
				}
				lng += ix;
				if (lng < -hlonunits) lng += lonunits2;
				if (lng >= hlonunits) lng -= lonunits2;

				if (iy > 0)
				{
					if (iy > 1) iy = getbits(iy-1)+pow2long[iy-1];
					if (getbits(1)) iy = -iy;
				}
				lat += iy;

				px[danumpoints] = lng;
				py[danumpoints] = lat;
				danumpoints++;
			}

				//Annoying case for the last string
			danumpoints = Ken_DPline(px,py,danumpoints,tolerance);
			polineto[numpoints>>3] |= (1<<(numpoints&7));
			ll[numpoints].lng = px[ind[0]];
			ll[numpoints].lat = py[ind[0]];
			numpoints++;
			for(j=1;j<danumpoints;j++)
			{
				dcossin(((double)py[ind[j-1]])*dscale,&t,&py1);
				dcossin(((double)px[ind[j-1]])*dscale,&pz1,&px1);
				px1 *= t; py1 = -py1; pz1 *= -t;
				dcossin(((double)py[ind[j]])*dscale,&t,&py2);
				dcossin(((double)px[ind[j]])*dscale,&pz2,&px2);
				px2 *= t; py2 = -py2; pz2 *= -t;
				t = (px2-px1)*(px2-px1) + (py2-py1)*(py2-py1) + (pz2-pz1)*(pz2-pz1);
				if (t > maxdist)
				{
					dtol(sqrt(t/maxdist),&splitit);
					if (splitit > 1)
					{
						t = 1.0 / splitit;
						dx = px[ind[j]] - px[ind[j-1]];
						dy = py[ind[j]] - py[ind[j-1]];
						for(z=splitit-1;z>0;z--)
						{
							dtol((double)px[ind[j]] - (double)dx*t*z,&ll[numpoints].lng);
							dtol((double)py[ind[j]] - (double)dy*t*z,&ll[numpoints].lat);
							numpoints++;
						}
					}
				}
				ll[numpoints].lng = px[ind[j]];
				ll[numpoints].lat = py[ind[j]];
				numpoints++;
			}

			close(globedatfil);
		}
		filepointlonunits[fcnt] = ((double)olonunits) / ilonunits;
	}

	memset(hfrq,0,sizeof(hfrq));

	hlonunits = (olonunits>>1); qlonunits = (olonunits>>2);
	log2lonunits = 1; while ((1<<log2lonunits) < olonunits) log2lonunits++;

	filepointcnt = 0;

	newnumpoints = numstrings = 0; ox = oy = 0;
	for(i=0;i<numpoints;i++)
	{
		if (i == filepointstart[filepointcnt])  //Update scale for different input file
			dascale = filepointlonunits[filepointcnt++];

			//quantize (make sure code's in sync - beware compiler optimizations)
		fifsyncmul(&ll[i].lng,&dascale,&nx);
		fifsyncmul(&ll[i].lat,&dascale,&ny);

		dx = nx-ox; dy = ny-oy;
		if (dx < -hlonunits) dx += olonunits;
		if (dx >= hlonunits) dx -= olonunits;
		if ((dx) || (dy))
		{
			if (!dx) lx = 0; else lx = bsr(labs(dx))+1;
			if (!dy) ly = 0; else ly = bsr(labs(dy))+1;
			z = (ly<<5)+lx; if (polineto[i>>3]&(1<<(i&7))) { z += 1024; numstrings++; }
			hfrq[z]++;
			newnumpoints++;
		}
		ox = nx; oy = ny;
	}


	for(z=0;z<2;z++)
		for(y=0;y<32;y++)
			for(x=0;x<32;x++)
				if (hfrq[(y<<5)+x+(z<<10)])
				{
					if (x+1 > hfrqend[0+(z<<1)]) hfrqend[0+(z<<1)] = x+1;
					if (y+1 > hfrqend[1+(z<<1)]) hfrqend[1+(z<<1)] = y+1;
				}

	genhuf(hfrq,2048,hufs,hufc);

	printf("\rHuffman bit lengths:\n");
	for(y=0;y<hfrqend[1];y++)
	{
		for(x=0;x<hfrqend[0];x++) printf("%2ld ",hufc[(y<<5)+x]);
		printf("\n");
	}
	printf("\n");
	for(y=0;y<hfrqend[3];y++)
	{
		for(x=0;x<hfrqend[2];x++) printf("%2ld ",hufc[(y<<5)+x+1024]);
		printf("\n");
	}

	for(i=0;i<2048;i++)
		if (hufc[i] > 25)
		{
			printf("Huffman bit count out of range! (>25) \n");
			fclose(infil);
			exit(0);
		}


	outfil = fopen(outfilename,"wb");

	fwrite(&olonunits,1,4,outfil);
	fwrite(&newnumpoints,1,4,outfil);

	bitval = bitpos = 0;  //Init putbits

		//Store huffman tables for both X and Y coordinates
	for(z=0;z<4;z++) putbits(hfrqend[z],5);
	for(y=0;y<hfrqend[1];y++)
		for(x=0;x<hfrqend[0];x++)
			putbits(hufc[(y<<5)+x],5);
	for(y=0;y<hfrqend[3];y++)
		for(x=0;x<hfrqend[2];x++)
			putbits(hufc[(y<<5)+x+1024],5);

	filepointcnt = 0;

	ox = oy = 0;
	for(i=0;i<numpoints;i++)
	{
		if (i == filepointstart[filepointcnt])  //Update scale for different input file
			dascale = filepointlonunits[filepointcnt++];

			//quantize (make sure code's in sync - beware compiler optimizations)
		fifsyncmul(&ll[i].lng,&dascale,&nx);
		fifsyncmul(&ll[i].lat,&dascale,&ny);

		dx = nx-ox; dy = ny-oy;
		if (dx < -hlonunits) dx += olonunits;
		if (dx >= hlonunits) dx -= olonunits;
		if ((dx) || (dy))
		{
			if (!dx) lx = 0; else lx = bsr(labs(dx))+1;
			if (!dy) ly = 0; else ly = bsr(labs(dy))+1;
			z = (ly<<5)+lx; if (polineto[i>>3]&(1<<(i&7))) z += 1024;
			putbits(hufs[z],hufc[z]);

			if (lx > 0)
			{
				if (lx > 1) putbits(labs(dx)-(1<<(lx-1)),lx-1);
				putbits(((unsigned long)dx)>>31,1);
			}
			if (ly > 0)
			{
				if (ly > 1) putbits(labs(dy)-(1<<(ly-1)),ly-1);
				putbits(((unsigned long)dy)>>31,1);
			}
		}
		ox = nx; oy = ny;
	}
	putbits(0,8-bitpos);  //Finish putbits (force last byte to be written)


	if (polineto) free(polineto);
	if (ll) free(ll);

	printf("Numpoints = %ld, Numstrings = %ld\n",newnumpoints,numstrings);
	printf("All done!\n");
}

#if 0
!endif
#endif
