#if 0
cshore.exe: cshore.c; cl /Ox /G6Fy cshore.c /MD /link /opt:nowin98
	del cshore.obj
!if 0
#endif

//03/01/2005: Upgraded code to handle GSHHS v1.3 database (Version 1.5 Sept 14, 2004)
//            Fixed bug: dx = nx+hlonunits; was sometimes equal to -1!
//12/23/2003: Port code to VC to make GLOBE.ZIP download smaller.
//            (File wasn't touched between 08/03/1999 and 12/23/2003)

#include <malloc.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>

#define MAXLOOPS 262144   //More loops than this will make it crash :(
#define PI 3.14159265358979323

	//30 MEGS: YUK! (must be as big as the largest loop in GSHHS_F.B)
long *px = 0, *py = 0, *ind = 0;
long *s0 = 0, *s1 = 0;

typedef struct { long loopnum, seekpos, spotval; } looptyp;
looptyp loop[MAXLOOPS];
long numloops, numpoints;

long bitval, bitpos;
long hfrq[1024], hufs[1024], hufc[1024], hfrqend[2];
FILE *infil, *outfil;

#ifdef __WATCOMC__

long bsr(long);
#pragma aux bsr=\
	"bsr ecx, eax"\
	parm [eax] value [ecx] modify nomemory exact [ecx]\

long bswap(long);
#pragma aux bswap=\
	"bswap eax"\
	parm [eax] value [eax] modify nomemory exact [eax]\

void dtol(double, long *);
#pragma aux dtol =\
	"fistp dword ptr [eax]",\
	parm [8087][eax]\

long mulscale32(long, long);
#pragma aux mulscale32 =\
	"imul edx",\
	parm nomemory [eax][edx] modify exact [eax edx] value [edx]\

void dcossin(double, double *, double *);
#pragma aux dcossin =\
	"fsincos",\
	"fstp qword ptr [eax]",\
	"fstp qword ptr [ebx]",\
	parm [8087][eax][ebx]\

//Ŀ
// Rounding: D11-10:   Precision: D9-8:   
//Ĵ
// 00 = near/even (0)  00 = 24-bit    (0) 
// 01 = -inf      (4)  01 = reserved  (1) 
// 10 = +inf      (8)  10 = 53-bit    (2) 
// 11 = 0         (c)  11 = 64-bit    (3) 
//

long asm;
#pragma aux fpuinit =\
	"fninit",\
	"fstcw asm",\
	"mov ah, byte ptr asm[1]",\
	"and ah, 0f0h",\
	"or ah, al",\
	"mov byte ptr asm[1], ah",\
	"fldcw asm",\
	parm [eax]\

#endif
#ifdef _MSC_VER

static __forceinline long bsr (long a) { _asm bsr eax, a }

static _inline unsigned long bswap (unsigned long a)
{
	_asm
	{
		mov eax, a
		bswap eax
	}
}

static _inline void dtol (double d, long *a)
{
	_asm
	{
		mov eax, a
		fld qword ptr d
		fistp dword ptr [eax]
	}
}

static _inline long mulscale32 (long a, long d)
{
	_asm
	{
		mov eax, a
		imul d
		mov eax, edx
	}
}

static _inline void dcossin (double a, double *c, double *s)
{
	_asm
	{
		fld a
		fsincos
		mov eax, c
		fstp qword ptr [eax]
		mov eax, s
		fstp qword ptr [eax]
	}
}

static long fpuasm[2];
static _inline void fpuinit (long a)
{
	_asm
	{
		mov eax, a
		fninit
		fstcw fpuasm
		and byte ptr fpuasm[1], 0f0h
		or byte ptr fpuasm[1], al
		fldcw fpuasm
	}
}

#endif

void genhuf (long *frq, long num, long *bsym, long *bcnt)
{
	static long ind[1024], cfrq[1024*2], par[1024*2];
	long k, z, zz, m0, m1, n, r, danum, nodecnt, maxbits;

	//----------------------------------------------------
	//Given: frq&(0 to num%), Calculate bcnt%(0 to num%-1)

		//Init destroyable index and frequency tables
	nodecnt = 0;
	for(z=0;z<num;z++)
		if (frq[z]) { cfrq[z] = frq[z]; ind[nodecnt++] = z; }

		//Generate huffman tree by saving parent links
	danum = num;
	for(;nodecnt>=2;nodecnt--)
	{
		if (cfrq[ind[1]] < cfrq[ind[0]]) { m0 = 1; m1 = 0; } else { m0 = 0; m1 = 1; }
		for(z=nodecnt-1;z>=2;z--)
			if (cfrq[ind[z]] < cfrq[ind[m1]])
			{
				if (cfrq[ind[z]] < cfrq[ind[m0]])
					{ m1 = m0; m0 = z; } else { m1 = z; }
			}

		par[ind[m0]] = danum;
		par[ind[m1]] = danum+16384;
		cfrq[danum] = cfrq[ind[m0]] + cfrq[ind[m1]];
		ind[m0] = danum;               //Replace m0%
		ind[m1] = ind[nodecnt-1];  //Delete m1%
		danum++;
	}

		//Count bits per symbol
	danum--;
	for(z=0;z<num;z++)
	{
		if (frq[z])
		{
			zz = z; bcnt[z] = 0;
			while (zz != danum)
			{
				bcnt[z]++;
				zz = (par[zz]&16383);
			}
		}
		else
			bcnt[z] = 0;
	}

	//----------------------------------------------------
	//Given: bcnt%(0 to num%), Calculate bsym&(0 to num%-1)

		//Init destroyable index table
	nodecnt = 0;
	for(z=0;z<num;z++)
		if (bcnt[z] > 0) ind[nodecnt++] = z;

		//Sort symbol bit sizes
	for(z=1;z<nodecnt;z++)
		for(zz=0;zz<z;zz++)
			if (bcnt[ind[z]] < bcnt[ind[zz]])
				{ k = ind[z]; ind[z] = ind[zz]; ind[zz] = k; }

		//Generate symbols
	n = 0; maxbits = bcnt[ind[nodecnt-1]];
	for(z=0;z<nodecnt;z++)
	{
		r = 0;
		for(zz=maxbits-1;zz>=0;zz--)
			if (n&(1<<zz)) r += (1<<(maxbits-1-zz));
		bsym[ind[z]] = r;
		n += (1<<(maxbits-bcnt[ind[z]]));
	}
}

//#define putbits(daval, dabits) \
//{ \
//   bitval += ((daval)<<bitpos); bitpos += (dabits); \
//   while (bitpos >= 8) \
//   { \
//      fputc(bitval,outfil); \
//      bitval >>= 8; bitpos -= 8; \
//   } \
//} \

#if 1
static void putbits (long daval, long dabits)
{
	bitval += (daval<<bitpos); bitpos += dabits;
	while (bitpos >= 8)
	{
		fputc(bitval,outfil);
		bitval >>= 8; bitpos -= 8;
	}
}
#endif

	//Returns data in ind[] and count in return value
long Ken_DP (long *dpx, long *dpy, long inum, double tolerance)
{
	double x0, y0, z0, x1, y1, z1, x2, y2, z2, x3, y3, z3, dsqr, maxdsqr, f;
	double rdist, minarea;
	long i, i0, i1, nleft, onum, s;

	if (inum < 3) return(0);
	if (tolerance == -1) //HACK FOR TESTING: Don't use this awful method!
	{
		onum = 0;
		for(i=0;i<inum-1;i+=4) ind[onum++] = i;
		ind[onum++] = inum-1;
		if ((dpx[ind[onum-1]] == dpx[ind[0]]) && (dpy[ind[onum-1]] == dpy[ind[0]])) onum--;
		if (onum < 3) return(0);
		return(onum);
	}
	if (tolerance <= 0)
	{
		for(i=0;i<inum;i++) ind[i] = i;
		return(inum);
	}

	tolerance /= 6371.007181;  //Divide by radius of the Earth (units in km)
	tolerance *= tolerance;

	onum = 0;

	f = 0.000001*PI/180.0;

		//init stack
	s0[0] = 0; s1[0] = inum-1; nleft = 1;

	do
	{
		nleft--; i0 = s0[nleft]; i1 = s1[nleft];
		if (i1-i0 > 1)
		{
			x0 = cos(dpy[i0]*f)*cos(dpx[i0]*f);
			y0 = cos(dpy[i0]*f)*sin(dpx[i0]*f);
			z0 = sin(dpy[i0]*f);

			x2 = cos(dpy[i1]*f)*cos(dpx[i1]*f);
			y2 = cos(dpy[i1]*f)*sin(dpx[i1]*f);
			z2 = sin(dpy[i1]*f);

			rdist = ((x2-x0)*(x2-x0) + (y2-y0)*(y2-y0) + (z2-z0)*(z2-z0));
			if (rdist != 0.0) rdist = 1.0 / rdist;

			maxdsqr = -1;
			for(i=i0+1;i<i1;i++)  //Find farthest point from line
			{
				x1 = cos(dpy[i]*f)*cos(dpx[i]*f);
				y1 = cos(dpy[i]*f)*sin(dpx[i]*f);
				z1 = sin(dpy[i]*f);

				if (rdist == 0)
					dsqr = (x1-x0)*(x1-x0) + (y1-y0)*(y1-y0) + (z1-z0)*(z1-z0);
				else
				{
						//dsqr = (3D distance between point 1 and line 0-2)
					if ((x1-x0)*(x2-x0) + (y1-y0)*(y2-y0) + (z1-z0)*(z2-z0) < 0)
						dsqr = (x1-x0)*(x1-x0) + (y1-y0)*(y1-y0) + (z1-z0)*(z1-z0);
					else if ((x1-x2)*(x0-x2) + (y1-y2)*(y0-y2) + (z1-z2)*(z0-z2) < 0)
						dsqr = (x1-x2)*(x1-x2) + (y1-y2)*(y1-y2) + (z1-z2)*(z1-z2);
					else
					{
						dsqr = ((x1-x0)*(x2-x0) + (y1-y0)*(y2-y0) + (z1-z0)*(z2-z0)) * rdist;
						x3 = x0 + (x2-x0)*dsqr;
						y3 = y0 + (y2-y0)*dsqr;
						z3 = z0 + (z2-z0)*dsqr;
						dsqr = (x3-x1)*(x3-x1) + (y3-y1)*(y3-y1) + (z3-z1)*(z3-z1);
					}
				}
				if (dsqr >= maxdsqr) { maxdsqr = dsqr; s = i; }
			}
			if (maxdsqr >= tolerance)
			{     //DO NOT REVERSE THESE!
				s0[nleft] = s; s1[nleft] = i1;
				s0[nleft+1] = i0; s1[nleft+1] = s;
				nleft += 2;
			}
			else ind[onum++] = i0;
		}
		else ind[onum++] = i0;
	} while (nleft > 0);
	ind[onum++] = inum-1;

	if ((dpx[ind[onum-1]] == dpx[ind[0]]) && (dpy[ind[onum-1]] == dpy[ind[0]])) onum--;
	if (onum < 3) return(0);
	if (onum == 3)  //Remove triangles with extremely small area
	{
		x0 = cos(dpy[ind[0]]*f)*cos(dpx[ind[0]]*f);
		y0 = cos(dpy[ind[0]]*f)*sin(dpx[ind[0]]*f);
		z0 = sin(dpy[ind[0]]*f);

		x1 = cos(dpy[ind[1]]*f)*cos(dpx[ind[1]]*f);
		y1 = cos(dpy[ind[1]]*f)*sin(dpx[ind[1]]*f);
		z1 = sin(dpy[ind[1]]*f);

		x2 = cos(dpy[ind[2]]*f)*cos(dpx[ind[2]]*f);
		y2 = cos(dpy[ind[2]]*f)*sin(dpx[ind[2]]*f);
		z2 = sin(dpy[ind[2]]*f);

		x1 -= x0; y1 -= y0; z1 -= z0;
		x2 -= x0; y2 -= y0; z2 -= z0;

			//minarea = 1E-18;
		minarea = (tolerance/6371.007181); minarea *= minarea;

			//minarea in units of area on surface of unit sphere
		x0 = y1*z2 - y2*z1;
		y0 = z1*x2 - z2*x1;
		z0 = x1*y2 - x2*y1;
		if ((x0*x0 + y0*y0 + z0*z0)*.5 > minarea) return(0);
	}
	return(onum);
}

	//Derived from GRIDPATH.BAS
long hilbert_index (long xx, long yy, long logn)
{
	long h, i, o, x, y;

	h = (1<<logn);
	if (xx < 0) xx = 0;
	if (yy < 0) yy = 0;
	if (xx > h-1) xx = h-1;
	if (yy > h-1) yy = h-1;

	i = o = 0;
	for(h>>=1;h>0;h>>=1)
	{
		if (xx >= h) { xx -= h; x = 1; } else x = 0;
		if (yy >= h) { yy -= h; y = 1; } else y = 0;
		i <<= 2;
		if (x == y) { if (x == (o&1)) o ^= 2; else i += 2; }
		else { if ((y<<1) == ((-o)&2)) i++; else { o ^= 3; i += 3; } }
	}
	return(i);
}

long hilbert_cube_index (double fx, double fy, double fz)
{
	double f;
	long x, y, z;

	if ((fabs(fx) > fabs(fy)) && (fabs(fx) > fabs(fz)))
	{
		f = 8192.0/fabs(fx);
		dtol(fy*f,&y); dtol(fz*f,&z);
		if (fx > 0) return(hilbert_index((1<<13)-z,(1<<13)+y,14)+(1<<28));
				 else return(hilbert_index((1<<13)-y,(1<<13)-z,14)+(3<<28));
	}
	else if (fabs(fy) > fabs(fz))
	{
		f = 8192.0/fabs(fy);
		dtol(fx*f,&x); dtol(fz*f,&z);
		if (fy > 0) return(hilbert_index((1<<13)-z,(1<<13)-x,14)+(2<<28));
				 else return(hilbert_index((1<<13)+x,(1<<13)+z,14)+(5<<28));
	}
		f = 8192.0/fabs(fz);
		dtol(fx*f,&x); dtol(fy*f,&y);
		if (fz > 0) return(hilbert_index((1<<13)+y,(1<<13)+x,14)+(0<<28));
						return(hilbert_index((1<<13)+x,(1<<13)-y,14)+(4<<28));
}

void main (int argc, char **argv)
{
	looptyp tl;
	double cx, cy, cz, sumx, sumy, sumz, t, radscale, tolerance;
	long i, j, k, l, m, n, n2, x, y, z, zz, dobswap, headsiz, gap, orign;
	long lonunits, hlonunits, qlonunits, log2lonunits, daftell, dascale;
	long dx, dy, nx, ny, ox, oy, origx, origy, lastpointprint, lx, ly;
	long hfrqbackup1;
	char infilename[256], outfilename[256], header[40];

	if ((argc != 4) && (argc != 5))
	{
		printf("CSHORE converts GSHHS*.B shoreline files to GLOBE files    by Ken Silverman\n");
		printf("   Automatically detects if input is Big or Little Endian format\n\n");
		printf("Command line: >CSHORE [infile] [outfile] [# angles] (tolerance)\n");
		printf("   [infile]: The GSHHS_?.B shoreline file\n");
		printf("   [outfile]: Output filename (in Ken's super-compressed GLOBE format)\n");
		printf("   [# angles]: Quantize angles to: 1: 360, 01': 21600, 00'1\": 1296000, etc.\n");
		printf("   (tolerance): Remove line info less significant than this length (in km)\n");
		printf("       (Uses a form of the Douglas-Peucker algorithm)\n");
		printf("       Use 0 to remove nothing. Use a very small number (such as 1e-8) to only\n");
		printf("       remove triangles with very small area.\n\n");
		printf("Example #1:  >cshore graftool.b shoreg.dat 21600 1e-8\n");
		printf("Example #2:  >cshore shores\\gshhs_c.b shorec.dat 32768 1e-8\n");
		printf("Example #3:  >cshore xearth.b shorex.dat 65536 1e-8\n");
		printf("Example #4:  >cshore shores\\gshhs_l.b shorel.dat 131072 1e-8\n");
		printf("Example #5:  >cshore shores\\gshhs_i.b shorei.dat 262144 1e-8\n");
		printf("Example #6:  >cshore shores\\gshhs_h.b shoreh.dat 524288 1e-8\n");
		printf("Example #7:  >cshore shores\\gshhs_f.b shoref.dat 12960000 0\n");
		exit(0);
	}

	setbuf(stdout,0);
	fpuinit(0x03);  //64 bit, round to +near/even

	strcpy(infilename,argv[1]);
	strcpy(outfilename,argv[2]);
	lonunits = atol(argv[3]);
	if (argc == 5) tolerance = atof(argv[4]); else tolerance = 0;

	hlonunits = (lonunits>>1); qlonunits = (lonunits>>2);
	log2lonunits = 1; while ((1<<log2lonunits) < lonunits) log2lonunits++;

	memset(hfrq,0,sizeof(hfrq));

		//(lonunits must be < 33554432 because huffman code only reads 25 bits)
		//lonunits must be < 180000000 for this statement to work correctly!
	if (lonunits >= 33554432)
		{ printf("Error: lonunits can't be >= 33554432\n"); exit(0); }
	dtol(((double)lonunits)*4294967296.0/360000000.0,&dascale);

	radscale = PI / 180000000.0; //Convert from microdegrees to radians

	if (!(px = (long *)malloc(1441792*4))) { printf("Out of memory (px)\n"); exit(0); }
	if (!(py = (long *)malloc(1441792*4))) { printf("Out of memory (py)\n"); exit(0); }
	if (!(ind= (long *)malloc(1441792*4))) { printf("Out of memory (ind)\n"); exit(0); }
	if (!(s0 = (long *)malloc(1441792*4))) { printf("Out of memory (s0)\n"); exit(0); }
	if (!(s1 = (long *)malloc(1441792*4))) { printf("Out of memory (s1)\n"); exit(0); }

	infil = fopen(infilename,"rb");

	numloops = numpoints = lastpointprint = 0;
	printf("         Analyzing file...");  //tabulate point & loop statistics
	fread(header,36,1,infil); daftell = 0;
	if ((*((long *)&header[8]))&0xffff0000) dobswap = 1; else dobswap = 0;

	i = *(long *)&header[32]; if (dobswap) i = bswap(i);
	if (i == 3) //Auto-detect if it's a GSHHS v1.3 database (Version 1.5 Sept 14, 2004)
		{ fread(&header[36],4,1,infil); headsiz = 40; } else headsiz = 36;

	while (1)
	{
		n = *((long *)&header[4]); if (dobswap) n = bswap(n);
		orign = n;
		for(z=0;z<n;z++)
		{
			fread(&x,4,1,infil);
			fread(&y,4,1,infil);
			if (dobswap) { x = bswap(x); y = bswap(y); }
			y = -y; if (x >= 180000000) x -= 360000000;
			px[z] = x;
			py[z] = y;
		}

		n = Ken_DP(px,py,n,tolerance);

		if (n >= 3)
		{
			n2 = 0;
			for(z=0;z<n;z++)
			{
					//quantize (don't use floating point because it loses sync!)
				nx = mulscale32(px[ind[z]],dascale);
				ny = mulscale32(py[ind[z]],dascale);

				if (!z)
				{
					origx = nx; origy = ny; n2++;

						//LPS calculations:
					dcossin(((double)py[ind[z]])*radscale,&t,&sumy);
					dcossin(((double)px[ind[z]])*radscale,&sumz,&sumx);
					sumx *= t; sumz *= -t;
				}
				else
				{
					if ((z == n-1) && (nx == origx) && (ny == origy)) break;
					dx = nx-ox; dy = ny-oy;
					if (dx < -hlonunits) dx += lonunits;
					if (dx >= hlonunits) dx -= lonunits;
					if ((dx) || (dy))
					{
						if (!dx) lx = 0; else lx = bsr(labs(dx))+1;
						if (!dy) ly = 0; else ly = bsr(labs(dy))+1;
						if (n2 == 1) //Hack: Don't modify counts if loop isn't used!
							hfrqbackup1 = (ly<<5)+lx;
						else
							hfrq[(ly<<5)+lx]++;
						n2++;

							//LPS calculations:
						dcossin(((double)py[ind[z]])*radscale,&t,&cy);
						dcossin(((double)px[ind[z]])*radscale,&cz,&cx);
						sumx += cx*t; sumy += cy; sumz -= cz*t;
					}
				}
				ox = nx; oy = ny;
			}
			if (n2 >= 3)
			{
				hfrq[hfrqbackup1]++;

				numpoints += n2;
				loop[numloops].seekpos = daftell;
				loop[numloops].loopnum = n2;

#if 0
					//LPS calculations:
				t = 16.0/sqrt(sumx*sumx + sumy*sumy + sumz*sumz);
				if ((fabs(sumx) > fabs(sumy)) && (fabs(sumx) > fabs(sumz)))
					{ dtol(sumy*t,&i); dtol(sumz*t,&j); if (sumx > 0) k = 0; else k = 3; }
				else if (fabs(sumy) > fabs(sumz))
					{ dtol(sumx*t,&i); dtol(sumz*t,&j); if (sumy > 0) k = 1; else k = 4; }
				else
					{ dtol(sumx*t,&i); dtol(sumy*t,&j); if (sumz > 0) k = 2; else k = 5; }
				loop[numloops].spotval = i + (j<<14) + (k<<28);
#else
					//This method is better for keeping local vector data near each other
					//             LPSTOTAL:
					//            OLD:   NEW:
					//SHOREX.DAT: 198 -> 153
					//SHOREH.DAT: 672 -> 516
					//SHOREF.DAT: 680 -> 528
				loop[numloops].spotval = hilbert_cube_index(sumx,sumy,sumz);
#endif

				numloops++;

				if (numpoints > lastpointprint+4096)
					{ printf("\r%d",numloops); lastpointprint = numpoints; }
			}
		}

		daftell += (orign<<3)+headsiz;

		if (!fread(header,headsiz,1,infil)) break;
	}

	printf("\rnumpoints = %ld, numloops = %ld\n",numpoints,numloops);

	printf("Optimizing for locality...");

	gap = 1; while (gap < numloops) gap = (gap<<1)+1;
	for(gap>>=1;gap>0;gap>>=1)
	{
		k = numloops-gap;
		for(i=0;i<k;i++)
		{
			x = i; tl = loop[x+gap];
			if (loop[x].spotval > tl.spotval)
			{
				do
				{
					loop[x+gap] = loop[x];
					x -= gap;
				} while ((x >= 0) && (loop[x].spotval > tl.spotval));
				loop[x+gap] = tl;
			}
		}
	}

	hfrq[0] = numloops;
	for(y=0;y<32;y++)
		for(x=0;x<32;x++)
			if (hfrq[(y<<5)+x])
			{
				if (x+1 > hfrqend[0]) hfrqend[0] = x+1;
				if (y+1 > hfrqend[1]) hfrqend[1] = y+1;
			}

	genhuf(hfrq,1024,hufs,hufc);

	printf("\rHuffman bit lengths:      \n");
	for(y=0;y<hfrqend[1];y++)
	{
		for(x=0;x<hfrqend[0];x++) printf("%2ld ",hufc[(y<<5)+x]);
		printf("\n");
	}

	for(i=0;i<1024;i++)
		if (hufc[i] > 25)
		{
			printf("Huffman bit count out of range! (>25) \n");
			fclose(infil);
			if (s1) { free(s1); s1 = 0; }
			if (s0) { free(s0); s0 = 0; }
			if (ind) { free(ind); ind = 0; }
			if (py) { free(py); py = 0; }
			if (px) { free(px); px = 0; }
			exit(0);
		}


	printf("         Writing file...");

	outfil = fopen(outfilename,"wb");

	fwrite(&lonunits,1,4,outfil);
	fwrite(&numloops,1,4,outfil);
	fwrite(&numpoints,1,4,outfil);

	bitval = bitpos = 0;  //Init putbits

		//Store huffman tables for both X and Y coordinates
	putbits(hfrqend[0],5);
	putbits(hfrqend[1],5);
	for(y=0;y<hfrqend[1];y++)
		for(x=0;x<hfrqend[0];x++)
			putbits(hufc[(y<<5)+x],5);

	numpoints = lastpointprint = 0;
	for(i=0;i<numloops;i++)
	{
		fseek(infil,loop[i].seekpos,SEEK_SET);
		fread(header,headsiz,1,infil);
		n = *((long *)&header[4]); if (dobswap) n = bswap(n);
		for(z=0;z<n;z++)
		{
			fread(&x,4,1,infil);
			fread(&y,4,1,infil);
			if (dobswap) { x = bswap(x); y = bswap(y); }
			y = -y; if (x >= 180000000) x -= 360000000;
			px[z] = x;
			py[z] = y;
		}

		n = Ken_DP(px,py,n,tolerance);

		zz = 0; z = 0; n = loop[i].loopnum;
		while (z < n)
		{
			x = px[ind[zz]]; y = py[ind[zz]]; zz++;

				//quantize (don't use floating point because it loses sync!)
			nx = mulscale32(x,dascale);
			ny = mulscale32(y,dascale);

			if (!z)
			{
				dx = nx+hlonunits; if (dx < 0) dx += lonunits; if (dx >= lonunits) dx -= lonunits;
				dy = ny+qlonunits; if (dy < 0) dy = 0; if (dy > hlonunits-1) dy = hlonunits-1;
				putbits(dx,log2lonunits);
				putbits(dy,log2lonunits-1);
				z++;
			}
			else
			{
				dx = nx-ox; dy = ny-oy;
				if (dx < -hlonunits) dx += lonunits;
				if (dx >= hlonunits) dx -= lonunits;
				if ((dx) || (dy))
				{
					if (!dx) lx = 0; else lx = bsr(labs(dx))+1;
					if (!dy) ly = 0; else ly = bsr(labs(dy))+1;
					putbits(hufs[(ly<<5)+lx],hufc[(ly<<5)+lx]);

					if (lx > 0)
					{
						if (lx > 1) putbits(labs(dx)-(1<<(lx-1)),lx-1);
						putbits(((unsigned long)dx)>>31,1);
					}
					if (ly > 0)
					{
						if (ly > 1) putbits(labs(dy)-(1<<(ly-1)),ly-1);
						putbits(((unsigned long)dy)>>31,1);
					}
					z++;
				}
			}
			ox = nx; oy = ny;
		}
		putbits(hufs[0],hufc[0]);
		numpoints += z;
		if (numpoints > lastpointprint+4096)
			{ printf("\r%d",i); lastpointprint = numpoints; }
	}
	putbits(0,8-bitpos);  //Finish putbits (force last byte to be written)

	fclose(outfil);
	fclose(infil);
	if (s1) { free(s1); s1 = 0; }
	if (s0) { free(s0); s0 = 0; }
	if (ind) { free(ind); ind = 0; }
	if (py) { free(py); py = 0; }
	if (px) { free(px); px = 0; }

	printf("\rAll done!               ");
}

#if 0
!endif
#endif
